## libocas 0.93

=== Makefile ===
MEXDETECTED := $(shell mex -h >/dev/null 2>&1 && echo yes)
MEX := mex
MEXFLAGS := $(shell if uname -m | grep -q x86_64 ; then echo -largeArrayDims ; fi)
MEXSUFFIX := $(shell if uname -m | grep -q x86_64 ; then echo mexa64 ; else echo mexglx ; fi)
CC := gcc
#CFLAGS := -g -lm -Wall -pthread
CFLAGS := -lm -msse -O3 -fPIC -fstrict-aliasing -fomit-frame-pointer -Wall -pthread
#CFLAGS := -lm -msse -O3 -fPIC -fstrict-aliasing -fomit-frame-pointer -Wall
#CFLAGS := -lm -msse -O3 -fPIC -fopenmp -fstrict-aliasing -fomit-frame-pointer -Wall


ifeq (yes,$(MEXDETECTED))
all: svmocas.$(MEXSUFFIX) svmlight_linclass.$(MEXSUFFIX) libocas.so svmocas msvmocas linclass msvmocas.$(MEXSUFFIX) compute_errors.$(MEXSUFFIX) lbppyr.$(MEXSUFFIX) svmocas_lbp.$(MEXSUFFIX) lbppyr_features.$(MEXSUFFIX) lbpfilter.$(MEXSUFFIX)

compute_errors.$(MEXSUFFIX): compute_errors_mex.c libocas.h ocas_helper.h ocas_helper.c
		$(MEX) $(MEXFLAGS) -DLIBOCAS_MATLAB -O -output compute_errors.$(MEXSUFFIX) compute_errors_mex.c ocas_helper.c lib_svmlight_format.c

svmocas.$(MEXSUFFIX): libocas.c libocas.h libqp_splx.c libqp.h svmocas_mex.c lib_svmlight_format.c lib_svmlight_format.h ocas_helper.c ocas_helper.h
		$(MEX) $(MEXFLAGS) -DLIBOCAS_MATLAB -O -output svmocas.$(MEXSUFFIX) svmocas_mex.c lib_svmlight_format.c ocas_helper.c  libocas.c libqp_splx.c
		
		
linclass_light.$(MEXSUFFIX): linclass_light_mex.c lib_svmlight_format.c lib_svmlight_format.h ocas_helper.c ocas_helper.h
		$(MEX) $(MEXFLAGS) -DLIBOCAS_MATLAB -O -output linclass_light.$(MEXSUFFIX) linclass_light_mex.c lib_svmlight_format.c ocas_helper.c

		
svmlight_linclass.$(MEXSUFFIX): svmlight_linclass_mex.c lib_svmlight_format.c lib_svmlight_format.h ocas_helper.c ocas_helper.h
		$(MEX) $(MEXFLAGS) -DLIBOCAS_MATLAB -O -output svmlight_linclass.$(MEXSUFFIX) svmlight_linclass_mex.c lib_svmlight_format.c ocas_helper.c
		
msvmocas.$(MEXSUFFIX): libocas.c libocas.h libqp_splx.c libqp.h msvmocas_mex.c lib_svmlight_format.c lib_svmlight_format.h ocas_helper.c ocas_helper.h
		$(MEX) $(MEXFLAGS) -DLIBOCAS_MATLAB -O -output msvmocas.$(MEXSUFFIX) msvmocas_mex.c lib_svmlight_format.c ocas_helper.c libocas.c libqp_splx.c
		
lbppyr.$(MEXSUFFIX): lbppyr_mex.c
		$(MEX) $(MEXFLAGS) -O -output lbppyr.$(MEXSUFFIX) lbppyr_mex.c 	

svmocas_lbp.$(MEXSUFFIX): libocas.c libocas.h libqp_splx.c libqp.h svmocas_lbp_mex.c ocas_lbp_helper.c ocas_lbp_helper.h liblbp.h liblbp.c
		$(MEX) $(MEXFLAGS) -DLIBOCAS_MATLAB -O -output svmocas_lbp.$(MEXSUFFIX) svmocas_lbp_mex.c ocas_lbp_helper.c  libocas.c libqp_splx.c liblbp.c

lbppyr_features.$(MEXSUFFIX): lbppyr_features_mex.c liblbp.c liblbp.h
		$(MEX) -g $(MEXFLAGS) -DLIBOCAS_MATLAB -O -output lbppyr_features.$(MEXSUFFIX) lbppyr_features_mex.c liblbp.c

lbpfilter.$(MEXSUFFIX): lbpfilter_mex.c
		$(MEX) $(MEXFLAGS) -DLIBOCAS_MATLAB -O -output lbpfilter.$(MEXSUFFIX) lbpfilter_mex.c


else 
all: libocas.so svmocas msvmocas
endif

svmocas:	svmocas.c lib_svmlight_format.c sparse_mat.c ocas_helper.c ocas_helper.h libocas.h sparse_mat.h libocas.c
		$(CC) $(CFLAGS) -o $@ svmocas.c lib_svmlight_format.c sparse_mat.c ocas_helper.c libocas.c libqp_splx.c

msvmocas:	msvmocas.c lib_svmlight_format.c sparse_mat.c ocas_helper.c ocas_helper.h libocas.h sparse_mat.h libocas.c
		$(CC) $(CFLAGS) -o $@ msvmocas.c lib_svmlight_format.c sparse_mat.c ocas_helper.c libocas.c libqp_splx.c

linclass:	linclass.c lib_svmlight_format.c libocas.h 
		$(CC) $(CFLAGS) -o $@ linclass.c lib_svmlight_format.c  


libocas.so:	libocas.c libocas.h libqp_splx.c libqp.h 
		$(CC) $(CFLAGS) -shared -o $@ libocas.c libqp_splx.c

clean: 
		rm -f *~ svmocas.$(MEXSUFFIX) svmlight_linclass.$(MEXSUFFIX) svmocas msvmocas linclass libocas.so msvmocas.$(MEXSUFFIX) lbpfilter.$(MEXSUFFIX) lbppyr_features.$(MEXSUFFIX) svmocas_lbp.$(MEXSUFFIX) lbppyr.$(MEXSUFFIX) compute_errors.$(MEXSUFFIX)

=== debian/changelog ===
libocas (0.93-1) unstable; urgency=low

  * Initial release (Closes: #585788)
  * debian/patches:
    - 0001-Properly-build-shared-and-static-libraries-programs

 -- Christian Kastner <debian@kvr.at>  Thu, 17 Jun 2010 16:38:22 +0200

=== debian/control ===
Source: libocas
Section: libs
Priority: optional
Maintainer: Christian Kastner <debian@kvr.at>
Build-Depends:
    debhelper (>= 7.0.50~)
Standards-Version: 3.8.4
Homepage: http://cmp.felk.cvut.cz/~xfrancv/ocas/html/
Vcs-Git: git://scm.kvr.at/git/pkg-libocas.git
Vcs-Browser: http://scm.kvr.at/git/pkg-libocas.git;a=summary

Package: libocas-dev
Section: libdevel
Architecture: any
Depends:
    ${misc:Depends},
    libocas0 (= ${binary:Version})
Description: Development libraries and header files for LIBOCAS
 This library implements Optimized Cutting Plane Algorithm (OCAS) for
 training linear Support Vector Machine (SVM) classifiers from
 large-scale data. The computational effort of OCAS scales linearly with
 the number of training examples. It is one of the fastest SVM solvers
 around for solving linear and multiclass L2 regularized SVMs.
 .
 This package contains the header files and static libraries.

Package: libocas0
Architecture: any
Depends:
    ${shlibs:Depends},
    ${misc:Depends}
Recommends:
    libocas-tools (= ${binary:Version})
Suggests:
    libocas-dev (= ${binary:Version})
Description: OCAS solver for training linear SVM classifiers
 This library implements Optimized Cutting Plane Algorithm (OCAS) for
 training linear Support Vector Machine (SVM) classifiers from
 large-scale data. The computational effort of OCAS scales linearly with
 the number of training examples. It is one of the fastest SVM solvers
 around for solving linear and multiclass L2 regularized SVMs.
 .
 This package contains the shared libraries.

Package: libocas-dbg
Priority: extra
Section: debug
Architecture: any
Depends:
    ${misc:Depends},
    libocas0 (= ${binary:Version}),
    libocas-tools (= ${binary:Version})
Description: Debugging symbols for LIBOCAS
 This library implements Optimized Cutting Plane Algorithm (OCAS) for
 training linear Support Vector Machine (SVM) classifiers from
 large-scale data. The computational effort of OCAS scales linearly with
 the number of training examples. It is one of the fastest SVM solvers
 around for solving linear and multiclass L2 regularized SVMs.
 .
 This package contains the debugging symbols.

Package: libocas-tools
Section: science
Architecture: any
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
    libocas0 (= ${binary:Version})
Description: Standalone applications implementing the OCAS solver
 This library implements Optimized Cutting Plane Algorithm (OCAS) for
 training linear Support Vector Machine (SVM) classifiers from
 large-scale data. The computational effort of OCAS scales linearly with
 the number of training examples. It is one of the fastest SVM solvers
 around for solving linear and multiclass L2 regularized SVMs.
 .
 This package contains the standalone applications.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Get version numbers for SONAME from changelog
DVER = $(shell dpkg-parsechangelog | grep '^Version')
LVER = $(shell echo $(DVER) | sed -e 's/Version: \([0-9]*\)\..*/\1/')
LSUBVER = $(shell echo $(DVER) | sed -e 's/Version: .*\.\([0-9]*\).*/\1/')
export LVER
export LSUBVER

CFLAGS = -Wall -g
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
    CFLAGS += -O0
else
    CFLAGS += -O3
ifeq (amd64,$(DEB_HOST_ARCH))
    CFLAGS += -msse
endif
endif

%:
	dh $@ 

override_dh_strip:
	dh_strip --dbg-package=libocas-dbg

=== debian/watch ===
version=3

opts=dversionmangle=s/\.// \
http://cmp.felk.cvut.cz/~xfrancv/ocas/libocas_v(.*).zip

## libocas 0.97

=== debian/changelog ===
libocas (0.97-1) unstable; urgency=medium

  * New upstream release.
    - Upstream renamed the linclass executable to linclassif
  * debian/libocas-tools.*
    debian/{linclassif,svmocas,msvmocas}.1:
    - Adjust for upstream-renamed executable
  * debian/NEWS:
    - Add to notify users of the renamed linclassif
  * Migrate git repo to Debian-Science at git.debian.org
  * debian/control:
    - Update VCS-* URLs to point to new location
    - Add XS-Testsuite for autopkgtest
  * debian/tests/*:
    - Add an autopkgtest "executables" that runs the examples from the
      documentation
  * debian/watch:
    - Mangle uversion instead of dversion, otherwise uscan renames using
      the unwanted version number
  * debian/libocas0.symbols:
    - Update with new symbol
  * debian/patches (refreshed):
    - 0001-Properly-build-shared-and-static-libraries-programs
      Refresh Makefile patch to new upstream version

 -- Christian Kastner <debian@kvr.at>  Sun, 24 Aug 2014 15:26:04 -0700

libocas (0.93-3) unstable; urgency=low

  * debian/control:
    - Add Multi-Arch fields to packages where necessary
    - Add Pre-Depends for package liblinear1
  * debian/rules:
    - Install to multi-arch locations
  * debian/patches (updated):
    - 0001-Properly-build-shared-and-static-libraries-programs
      Add an install target to upstream's Makefile, with configurable
      destinations for libraries and executables
  * debian/*.install:
    - Update paths as a consequence of the new install target and
      multi-arch-ification

 -- Christian Kastner <debian@kvr.at>  Sun, 27 Jul 2014 00:52:22 +0200

libocas (0.93-2) unstable; urgency=low

  * debian/copyright:
    - Corrected upstream license version from GPL-3+ to GPL-3. Thanks to
      Vincent Cheng for catching this. Closes: #751668
  * debian/control:
    - Bumped Standards-Version to 3.9.5 (no changes required)
    - Bumped debhelper dependency to 9
    - Demoted libocas0's Recommends for libocas-tools to Suggests, so
      packages depending only on the library don't pull in the tools.
  * debian/compat:
    - Bumped debhelper compatibility level to recommended level 9
  * debian/copyright:
    - Refreshed to machine-readable copyright format 1.0
  * debian/rules:
    - Use DEB_CFLAGS_MAINT_APPEND, as recommended, instead of CFLAGS
  * debian/patches (modified):
    - 0001-Properly-build-shared-and-static-libraries-programs
      Include CPPFLAGS to avoid hardening flag warnings
  * debian/source/lintian-overrides:
    - Added override for debian-watch-may-check-gpg-signature
  * debian/libocas-tools.lintian-overrides:
    - Added override for arch-dep-package-has-big-usr-share

 -- Christian Kastner <debian@kvr.at>  Wed, 19 Feb 2014 15:33:14 +0100

=== debian/control ===
--- 
+++ 
@@ -3,15 +3,17 @@
 Priority: optional
 Maintainer: Christian Kastner <debian@kvr.at>
 Build-Depends:
-    debhelper (>= 7.0.50~)
-Standards-Version: 3.8.4
+    debhelper (>= 9)
+Standards-Version: 3.9.5
+XS-Testsuite: autopkgtest
 Homepage: http://cmp.felk.cvut.cz/~xfrancv/ocas/html/
-Vcs-Git: git://scm.kvr.at/git/pkg-libocas.git
-Vcs-Browser: http://scm.kvr.at/git/pkg-libocas.git;a=summary
+Vcs-Git: git://anonscm.debian.org/debian-science/packages/libocas.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/libocas.git
 
 Package: libocas-dev
 Section: libdevel
 Architecture: any
+Multi-Arch: same
 Depends:
     ${misc:Depends},
     libocas0 (= ${binary:Version})
@@ -26,13 +28,14 @@
 
 Package: libocas0
 Architecture: any
+Multi-Arch: same
+Pre-Depends:
+    ${misc:Pre-Depends}
 Depends:
     ${shlibs:Depends},
     ${misc:Depends}
-Recommends:
+Suggests:
     libocas-tools (= ${binary:Version})
-Suggests:
-    libocas-dev (= ${binary:Version})
 Description: OCAS solver for training linear SVM classifiers
  This library implements Optimized Cutting Plane Algorithm (OCAS) for
  training linear Support Vector Machine (SVM) classifiers from
@@ -46,6 +49,7 @@
 Priority: extra
 Section: debug
 Architecture: any
+Multi-Arch: same
 Depends:
     ${misc:Depends},
     libocas0 (= ${binary:Version}),
@@ -62,6 +66,7 @@
 Package: libocas-tools
 Section: science
 Architecture: any
+Multi-Arch: foreign
 Depends:
     ${shlibs:Depends},
     ${misc:Depends},

=== debian/rules ===
--- 
+++ 
@@ -11,18 +11,23 @@
 export LVER
 export LSUBVER
 
-CFLAGS = -Wall -g
+export DEB_CFLAGS_MAINT_APPEND = -Wall -g
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
-    CFLAGS += -O0
+    DEB_CFLAGS_MAINT_APPEND += -O0
 else
-    CFLAGS += -O3
+    DEB_CFLAGS_MAINT_APPEND += -O3
 ifeq (amd64,$(DEB_HOST_ARCH))
-    CFLAGS += -msse
+    DEB_CFLAGS_MAINT_APPEND += -msse
 endif
 endif
 
+DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+
 %:
-	dh $@ 
+	dh $@
+
+override_dh_auto_install:
+	dh_auto_install -- libdir=/usr/lib/$(DEB_HOST_MULTIARCH)/
 
 override_dh_strip:
 	dh_strip --dbg-package=libocas-dbg

=== debian/watch ===
version=3

opts=uversionmangle=s/^0/0\./ \
http://cmp.felk.cvut.cz/~xfrancv/ocas/libocas_v(.*).zip

## libocas 0.97%2Bdfsg

=== debian/changelog ===
libocas (0.97+dfsg-6) unstable; urgency=medium

  * d/source/lintian-overrides: Fix syntax issue
  * d/rules: override_dh_missing for --fail-missing
  * d/control: Bump Standards-Version to 4.4.1 (no changes needed)
  * Let dh_install install from debian/tmp, instead of source.
    Resolves a warning from dh_missing. Thanks, Niels Thykier, for the analysis and
    resolution!
  * Add Build-Depends-Package to symbols file
  * Add Fix-spelling-error.patch

 -- Christian Kastner <ckk@debian.org>  Sun, 13 Oct 2019 21:10:13 +0200

libocas (0.97+dfsg-5) unstable; urgency=medium

  * Add Rules-Requires-Root: no
    We don't need (fake)root for building the packages
  * Move our manpages from d/ to d/man
  * Drop d/*.dirs, the dh_* helpers create directories as needed
  * Break overlong line in previous changelog 0.97+dfsg-4
  * d/tests: Rename ADTTMP to AUTOPKGTEST_TMP
  * Reformat d/watch
  * Override lintian debian-watch-uses-insecure-uri
    Upstream does not offer https

 -- Christian Kastner <ckk@debian.org>  Sat, 16 Feb 2019 07:48:45 +0100

libocas (0.97+dfsg-4) unstable; urgency=medium

  * Point Vcs-* to Salsa
  * Bump Standards-Version to 4.3.0 (no changes needed)
  * Switch Build-Depends from debhelper to debhelper-compat
  * Bump Build-Depends for debhelper-compat to 12
  * Remove now obsolete d/compat
  * Update d/watch to format version 4
  * Remove d/source/lintian-overrides
    The only tag listed has been re-classified as experimental
  * Move Files-Excluded to d/copyright (from standalone file)
  * d/rules:
    - Drop get-orig-source target
      uscan with Files-Excluded is sufficient
    - Drop override_dh_strip
      It was only needed for the dbgsym migration
    - Use DEB_VERSION_UPSTREAM from dpkg/pkg-info.mk instead of parsing
      d/changelog
  * gbp.conf: Add pristine-tar, sign-tags options
  * d/copyright: Switch to https in Format field

 -- Christian Kastner <ckk@debian.org>  Mon, 11 Feb 2019 21:13:54 +0100

libocas (0.97+dfsg-3) unstable; urgency=medium

  * The previous changelog was erroneous, it contained two stale entries:
    - d/patches (updated)
    - d/rules
    Their corrections are listed in this changelog entry.
  * d/patches (updated):
    - Update patch Properly-build-shared-and-static-libraries-programs
      Filter out -pie, -fpie, and -fPIE when building the shared library
    - Drop patch numbers from .patch filenames
  * d/rules:
    - Add hardening=+all to DEB_BUILD_MAINT_OPTIONS
  * d/gbp.conf:
    - Compress builds using xz

 -- Christian Kastner <ckk@debian.org>  Sat, 23 Apr 2016 08:48:21 +0200

libocas (0.97+dfsg-2) unstable; urgency=medium

  * Drop package libocas-dbg in favor of automatic dbgsym packages, as per
    https://lists.debian.org/debian-devel/2015/12/msg00262.html
  * Add d/gbp.conf to disable patch numbering
  * d/control:
    - Bump Standards-Version to 3.9.8 (no changes needed)
    - Switch Maintainer email to my @debian.org address
    - Switch Vcs-Browser from gitweb to cgit
    - Switch Vcs-* from insecure URIs to secure ones
  * d/patches (updated):
    - Update patch 0001-Properly-build-shared-and-static-libraries-programs
      Add separate targets for building libraries and executables
    - Drop patch numbers from .patch filenames
  * d/copyright:
    - Bump copyright years
  * d/rules:
    - Add hardening=+bindnow to DEB_BUILD_MAINT_OPTIONS
    - Add hardening=+pie to DEB_BUILD_MAINT_OPTIONS of executables

 -- Christian Kastner <ckk@debian.org>  Thu, 21 Apr 2016 19:55:20 +0200

libocas (0.97+dfsg-1) unstable; urgency=medium

  * Rebase packaging on DFSG-cleaned upstream source.
  * debian/control:
    - Bump Standards-Version to 3.9.6 (no changes needed)
    - Drop XS-Testsuite. dpkg now recognizes the Testsuite header, and
      dpkg-source automatically adds one when an autopkgtest suite is found
  * debian/rules:
    - Improve version information extraction
    - Add a git-orig-source target that DFSG-cleans. The DFSG-cleaning is
      performed by uscan with the Files-Excluded header. However, as this
      header is not yet part of the official MRCF, it is placed in a separate
      file 'debian/files-excluded'
  * debian/copyright:
    - Document the DFSG-cleaning actions
    - Bump copyright years
  * debian/watch:
    - Adjust for DFSG-cleaned upstream source

 -- Christian Kastner <debian@kvr.at>  Sat, 11 Jul 2015 17:05:39 +0200

=== debian/watch ===
version=4

# CK 2019-02-16: Upstream doesn't support https

opts=uversionmangle=s/^0/0\./,\
dversionmangle=s/\+dfsg//,\
repacksuffix=+dfsg \
http://cmp.felk.cvut.cz/~xfrancv/ocas/libocas_v(.*).zip

## libocas 0.97+dfsg

=== Makefile ===
MEXDETECTED := $(shell mex -h >/dev/null 2>&1 && echo yes)
MEX := mex
MEXFLAGS := $(shell if uname -m | grep -q x86_64 ; then echo -largeArrayDims ; fi)
MEXSUFFIX := $(shell if uname -m | grep -q x86_64 ; then echo mexa64 ; else echo mexglx ; fi)
CC := gcc
#CFLAGS := -g -lm -Wall -pthread
CFLAGS := -msse -O3 -fPIC -fstrict-aliasing -fomit-frame-pointer -Wall -pthread
CLIBS := -lm
#CFLAGS := -lm -msse -O3 -fPIC -fstrict-aliasing -fomit-frame-pointer -Wall
#CFLAGS := -lm -msse -O3 -fPIC -fopenmp -fstrict-aliasing -fomit-frame-pointer -Wall


ifeq (yes,$(MEXDETECTED))
all: svmocas_nnw.$(MEXSUFFIX) svmocas.$(MEXSUFFIX) svmocas_light.$(MEXSUFFIX) linclassif_light.$(MEXSUFFIX) libocas.so svmocas msvmocas linclassif msvmocas.$(MEXSUFFIX) msvmocas_light.$(MEXSUFFIX) compute_auc.$(MEXSUFFIX) svmocas_lbp.$(MEXSUFFIX) svmocas_bool.$(MEXSUFFIX) lbppyr_features.$(MEXSUFFIX) load_svmlight_file.$(MEXSUFFIX)

compute_auc.$(MEXSUFFIX): compute_auc_mex.c libocas.h ocas_helper.h ocas_helper.c version.h
		$(MEX) $(MEXFLAGS) -DLIBOCAS_MATLAB -O -output compute_auc.$(MEXSUFFIX) compute_auc_mex.c ocas_helper.c lib_svmlight_format.c

svmocas.$(MEXSUFFIX): libocas.c libocas.h libqp_splx.c libqp.h svmocas_mex.c lib_svmlight_format.c lib_svmlight_format.h ocas_helper.c ocas_helper.h features_int8.h features_int8.c features_double.h features_double.c features_single.h features_single.c
		$(MEX) $(MEXFLAGS) -DLIBOCAS_MATLAB -O -output svmocas.$(MEXSUFFIX) svmocas_mex.c ocas_helper.c lib_svmlight_format.c features_int8.c features_double.c features_single.c libocas.c libqp_splx.c

svmocas_nnw.$(MEXSUFFIX): libocas.c libocas.h libqp_splx.c libqp.h svmocas_nnw_mex.c lib_svmlight_format.c lib_svmlight_format.h ocas_helper.c ocas_helper.h features_int8.h features_int8.c features_double.h features_double.c features_single.h features_single.c
		$(MEX) $(MEXFLAGS) -DLIBOCAS_MATLAB -O -output svmocas_nnw.$(MEXSUFFIX) svmocas_nnw_mex.c lib_svmlight_format.c ocas_helper.c features_int8.c features_double.c features_single.c libocas.c libqp_splx.c

svmocas_light.$(MEXSUFFIX): libocas.c libocas.h libqp_splx.c libqp.h svmocas_light_mex.c lib_svmlight_format.c lib_svmlight_format.h ocas_helper.c ocas_helper.h features_double.h features_double.c
		$(MEX) $(MEXFLAGS) -DLIBOCAS_MATLAB -O -output svmocas_light.$(MEXSUFFIX) svmocas_light_mex.c lib_svmlight_format.c ocas_helper.c features_double.c libocas.c libqp_splx.c
		
linclassif_light.$(MEXSUFFIX): linclassif_light_mex.c lib_svmlight_format.c lib_svmlight_format.h ocas_helper.c ocas_helper.h
		$(MEX) $(MEXFLAGS) -DLIBOCAS_MATLAB -O -output linclassif_light.$(MEXSUFFIX) linclassif_light_mex.c lib_svmlight_format.c ocas_helper.c

msvmocas.$(MEXSUFFIX): libocas.c libocas.h libqp_splx.c libqp.h msvmocas_mex.c lib_svmlight_format.c lib_svmlight_format.h ocas_helper.c ocas_helper.h features_double.h features_double.c
		$(MEX) $(MEXFLAGS) -DLIBOCAS_MATLAB -O -output msvmocas.$(MEXSUFFIX) msvmocas_mex.c lib_svmlight_format.c ocas_helper.c features_double.c libocas.c libqp_splx.c

msvmocas_light.$(MEXSUFFIX): libocas.c libocas.h libqp_splx.c libqp.h msvmocas_light_mex.c lib_svmlight_format.c lib_svmlight_format.h ocas_helper.c ocas_helper.h features_double.h features_double.c
		$(MEX) $(MEXFLAGS) -DLIBOCAS_MATLAB -O -output msvmocas_light.$(MEXSUFFIX) msvmocas_light_mex.c lib_svmlight_format.c ocas_helper.c features_double.c libocas.c libqp_splx.c
		
lbppyr.$(MEXSUFFIX): lbppyr_mex.c
		$(MEX) $(MEXFLAGS) -O -output lbppyr.$(MEXSUFFIX) lbppyr_mex.c 	

svmocas_lbp.$(MEXSUFFIX): libocas.c libocas.h libqp_splx.c libqp.h svmocas_lbp_mex.c ocas_lbp_helper.c ocas_lbp_helper.h liblbp.h liblbp.c
		$(MEX) $(MEXFLAGS) -DLIBOCAS_MATLAB -O -output svmocas_lbp.$(MEXSUFFIX) svmocas_lbp_mex.c ocas_lbp_helper.c  libocas.c libqp_splx.c liblbp.c

svmocas_bool.$(MEXSUFFIX): libocas.c libocas.h libqp_splx.c libqp.h svmocas_bool_mex.c features_bool.c features_bool.h liblbp.h liblbp.c
		$(MEX) $(MEXFLAGS) -DLIBOCAS_MATLAB -O -output svmocas_bool.$(MEXSUFFIX) svmocas_bool_mex.c features_bool.c ocas_helper.c lib_svmlight_format.c libocas.c libqp_splx.c 

lbppyr_features.$(MEXSUFFIX): lbppyr_features_mex.c liblbp.c liblbp.h
		$(MEX) -g $(MEXFLAGS) -DLIBOCAS_MATLAB -O -output lbppyr_features.$(MEXSUFFIX) lbppyr_features_mex.c liblbp.c

lbpfilter.$(MEXSUFFIX): lbpfilter_mex.c
		$(MEX) $(MEXFLAGS) -DLIBOCAS_MATLAB -O -output lbpfilter.$(MEXSUFFIX) lbpfilter_mex.c

load_svmlight_file.$(MEXSUFFIX): load_svmlight_file.c lib_svmlight_format.c lib_svmlight_format.h
		$(MEX) $(MEXFLAGS) -DLIBOCAS_MATLAB -O -output load_svmlight_file.$(MEXSUFFIX) load_svmlight_file.c lib_svmlight_format.c

else 
all: libocas.so svmocas msvmocas linclassif
endif

svmocas:	svmocas.c svmocas.c lib_svmlight_format.c sparse_mat.c ocas_helper.c ocas_helper.h libocas.h sparse_mat.h libocas.c features_double.h features_double.c version.h
		$(CC) $(CFLAGS) -o $@ svmocas.c lib_svmlight_format.c sparse_mat.c ocas_helper.c features_double.c libocas.c libqp_splx.c $(CLIBS)

msvmocas:	msvmocas.c lib_svmlight_format.c sparse_mat.c ocas_helper.c ocas_helper.h libocas.h sparse_mat.h libocas.c features_double.h features_double.c version.h
		$(CC) $(CFLAGS) -o $@ msvmocas.c lib_svmlight_format.c sparse_mat.c ocas_helper.c features_double.c libocas.c libqp_splx.c $(CLIBS)

linclassif:	linclassif.c lib_svmlight_format.c libocas.h version.h
		$(CC) $(CFLAGS) -o $@ linclassif.c lib_svmlight_format.c $(CLIBS)


libocas.so:	libocas.c libocas.h libqp_splx.c libqp.h
		$(CC) $(CFLAGS) -shared -o $@ libocas.c libqp_splx.c $(CLIBS)

clean: 
		rm -f *~ svmocas.$(MEXSUFFIX) svmocas_nnw.$(MEXSUFFIX) svmocas_bool.$(MEXSUFFIX) svmocas_light.$(MEXSUFFIX) linclassif_light.$(MEXSUFFIX) svmocas msvmocas linclassif libocas.so msvmocas.$(MEXSUFFIX) msvmocas_light.$(MEXSUFFIX) lbppyr_features.$(MEXSUFFIX) svmocas_lbp.$(MEXSUFFIX) compute_auc.$(MEXSUFFIX) load_svmlight_file.$(MEXSUFFIX)

=== debian/control ===
Source: libocas
Section: libs
Priority: optional
Maintainer: Christian Kastner <ckk@debian.org>
Build-Depends:
    debhelper (>= 9),
Standards-Version: 3.9.8
Homepage: http://cmp.felk.cvut.cz/~xfrancv/ocas/html/
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/libocas.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/libocas.git

Package: libocas-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
    ${misc:Depends},
    libocas0 (= ${binary:Version}),
Description: Development libraries and header files for LIBOCAS
 This library implements Optimized Cutting Plane Algorithm (OCAS) for
 training linear Support Vector Machine (SVM) classifiers from
 large-scale data. The computational effort of OCAS scales linearly with
 the number of training examples. It is one of the fastest SVM solvers
 around for solving linear and multiclass L2 regularized SVMs.
 .
 This package contains the header files and static libraries.

Package: libocas0
Architecture: any
Multi-Arch: same
Pre-Depends:
    ${misc:Pre-Depends},
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
Suggests:
    libocas-tools (= ${binary:Version}),
Description: OCAS solver for training linear SVM classifiers
 This library implements Optimized Cutting Plane Algorithm (OCAS) for
 training linear Support Vector Machine (SVM) classifiers from
 large-scale data. The computational effort of OCAS scales linearly with
 the number of training examples. It is one of the fastest SVM solvers
 around for solving linear and multiclass L2 regularized SVMs.
 .
 This package contains the shared libraries.

Package: libocas-tools
Section: science
Architecture: any
Multi-Arch: foreign
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
    libocas0 (= ${binary:Version}),
Description: Standalone applications implementing the OCAS solver
 This library implements Optimized Cutting Plane Algorithm (OCAS) for
 training linear Support Vector Machine (SVM) classifiers from
 large-scale data. The computational effort of OCAS scales linearly with
 the number of training examples. It is one of the fastest SVM solvers
 around for solving linear and multiclass L2 regularized SVMs.
 .
 This package contains the standalone applications.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Get version information
PKGDIR := $(dir $(firstword $(MAKEFILE_LIST)))..
DEBVER := $(shell dpkg-parsechangelog -l$(PKGDIR)/debian/changelog -S Version)
UPVER := $(shell echo $(DEBVER) | sed -re 's/\+dfsg-.*//')
LVER = $(shell echo $(UPVER) | sed -nre 's/([0-9]+)\..*/\1/p')
LSUBVER = $(shell echo $(UPVER) | sed -nre 's/[0-9]\.([0-9]+).*/\1/p')
# Version information is needed by the build process
export LVER
export LSUBVER

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -g
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
    DEB_CFLAGS_MAINT_APPEND += -O0
else
    DEB_CFLAGS_MAINT_APPEND += -O3
ifeq (amd64,$(DEB_HOST_ARCH))
    DEB_CFLAGS_MAINT_APPEND += -msse
endif
endif

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)


%:
	dh $@


override_dh_auto_install:
	dh_auto_install -- libdir=/usr/lib/$(DEB_HOST_MULTIARCH)/


override_dh_strip:
	dh_strip --dbgsym-migration='libocas-dbg (<< $(DEBVER)~)'


# Remove upstream's non-DFSG-compliant files
get-orig-source:
	uscan \
		--noconf \
		--download-version $(UPVER) \
		--force-download \
		--check-dirname-level=0 \
		--destdir=$(CURDIR) \
		--rename \
		--repack \
		--compression xz \
		--copyright-file=$(PKGDIR)/debian/files-excluded \
		$(PKGDIR)

=== debian/tests/control ===
Tests: executables
Depends: libocas-tools

=== debian/watch ===
version=3

opts=uversionmangle=s/^0/0\./,dversionmangle=s/\+dfsg//,repacksuffix=+dfsg \
http://cmp.felk.cvut.cz/~xfrancv/ocas/libocas_v(.*).zip
